@echo off

REM set the HOME environment variable if not yet done
if %HOME%.==. set HOME=.

REM Start of parameters to edit
REM vvvvvvvvvvvvvvvvvvvvvvvvvvv

REM encrypt RSA private key (yes or no)
set encpkey=yes

REM RSA key size in bits
set keysize=1024

REM validity of keys in days
set valid=1095

REM server SSL key and CSR generation
set srvkey=.\server_pkey.pem
set srvreq=.\server_cert.req

REM path prefix for 'openssl' command
set prefix=.\bin

REM openssl configuration used for CSR generation
set config=.\request.cnf

REM ^^^^^^^^^^^^^^^^^^^^^^^^^
REM End of parameters to edit

%prefix%\openssl req -config %config% -newkey %keysize% -keyout %srvkey% -out %srvreq% -days %valid%

if ERRORLEVEL 1 goto error
echo.
echo Server key and certificate signing request (CSR) were generated.
echo Keep your new private key '%srvkey%' in a secure place
echo and send the CSR '%srvreq%' for signing to your CA.
goto exit

:error
if exist %srvkey% goto abort
echo.
echo Command '%prefix%\openssl' returned with error.
if exist %srvkey% del %srvkey%
if exist %srvreq% del %srvreq%
goto exit

:abort
echo.
echo Possible user abort of command '%prefix%\openssl'.
if exist %srvkey% del %srvkey%
if exist %srvreq% del %srvreq%

:exit
