#!/usr/bin/perl

# Start of parameters to edit
# >>>>>>>>>>>>>>>>>>>>>>>>>>>

if ($^O =~ /MSWin32/ && length($ENV{HOME}) == 0) {
   $ENV{HOME} = ".";
}

# encrypt RSA private key
$encpkey = "yes";

# RSA key size in bits
$keysize = "1024";

# validity of keys in days
$valid = "1095";

# server SSL key and CSR generation
$srvkey = "./server_pkey.pem";
$srvreq = "./server_cert.req";

# path prefix for 'openssl' command
$prefix = ($^O =~ /MSWin32/) ? "./bin/" : "";

# openssl configuration used for CSR generation
$config = "./Request.cnf";

# <<<<<<<<<<<<<<<<<<<<<<<<<
# End of parameters to edit

$ENV{ENCPKEY} = $encpkey;
@args = ($prefix."/openssl", "req", "-config", $config, "-newkey", $keysize, "-keyout", $srvkey, "-out", $srvreq, "-days", $valid);
print "System call:\n@args\n";
$retcode = system(@args);

$retcode >>= 8;
if ($retcode) {
   print STDERR "\nCommand '$prefix"."openssl' returned with error code $retcode.\n";
   unlink $srvkey, $srvreq;
} elsif ( !-e $srvreq ) {
   print STDERR "\nPossible user abort of command '$prefix/openssl'.\n";
   unlink $srvkey;
} else {
   print "\nServer key and certificate signing request (CSR) were generated.\n";
   print "Keep your new private key '$srvkey' in a secure place\n";
   print "and send the CSR '$srvreq' for signing to your CA.\n";
};